function ToggleVote()
	if(ElgohVote:IsShown()) then 
		ElgohVote:Hide();
		frmMain:SetHeight(frmMain:GetHeight()-ElgohVote:GetHeight())
	else
		if(edtVoteTitle:GetText()=="") then edtVoteTitle:SetText("Vote Title"); end
		ElgohVote:Show();
		frmMain:SetHeight(frmMain:GetHeight()+ElgohVote:GetHeight())
	end
end

function OVoteT()
	if(OElgohVote:IsShown()) then 
		OElgohVote:Hide();
		frmOfficer:SetHeight(frmOfficer:GetHeight()-OElgohVote:GetHeight())
	else
		OElgohVote:Show();
		OElgohVote:SetWidth(frmOfficer:GetWidth());
		frmOfficer:SetHeight(frmOfficer:GetHeight()+OElgohVote:GetHeight())
		Poll_New();
	end
end

function Vote_Refresh()
	for n=1,#PollItems do
		if(VoteButtons[n]==nil) then
			VoteButtons[n]=CreateFrame("Button",nil,caMain,"UIPanelButtonTemplate")
			VoteButtons[n]:RegisterForClicks("AnyUp");
			VoteButtons[n]:SetScript("OnClick", toggle);
			if(n<6) then
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 15, -((n*25)));
			else
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 180, -(((n-5)*25)));
			end
			VoteButtons[n]:SetWidth(150)
			VoteButtons[n]:SetHeight(25)
		end
		if(GetRaidRosterInfo(n)) then
			VoteButtons[n]:SetText("|cffffffff"..raidername.." hasn't given|r");
			height=height+25;
		else
			VoteButtons[n]:Hide();
		end
	end
end

function Poll_New()
	PollItems = {}
	PollVotes = {}
	PollVoting = false
	PollTitle = ""
end

function Poll_SetItem(itemName, index)
	local i

	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	Poll_OrderItems()
	DEFAULT_CHAT_FRAME:AddMessage(index..": "..itemName,1,1,1)

	return true
end


-- Poll_RemoveItem((integer) index)
--
-- Removes the item at index

function Poll_RemoveItem(index)
	if (PollItems[index] == nil) then
		PlaySoundFile("Sound\\interface\\Error.wav")
		return false
	end

	table.remove(PollItems, index)
	Poll_OrderItems()
	return true
end


-- Poll_List()
--
-- Shows the list of items

function Poll_List()
	local index, itemName

	if(PollTitle ~= "") then
	end

	for index, itemName in pairs(PollItems) do
		DEFAULT_CHAT_FRAME:AddMessage(index..": "..itemName,1,1,1)
	end
end


-- Poll_Vote( (string) player, (string) indexOrItemName, (boolean) withVoteCommand)
--
-- Sets a vote for a player

function Poll_Vote(player, indexOrItemName, withVoteCommand)
	local index
	local indexValid, alreadyVoted

	-- Not voting, nothing to do here
	if (not PollVoting) then
		return false
	end

	-- Get numeric index
	index = tonumber(indexOrItemName)

	-- Not a numeric index, find index from item name
	if (index == nil) then
		index = Poll_GetIndexByItemName(indexOrItemName)
	end

	-- The index is not valid
	indexValid = (index ~= nil) and (PollItems[index] ~= nil)

	-- Check if player already voted
	alreadyVoted = (PollVotes[player] ~= nil)

	-- No vote if already voted or invalid index
	if (not indexValid or alreadyVoted) then
		return false
	end

	-- Proceed vote
	PollVotes[player] = {}
	PollVotes[player]['notify'] = false
	PollVotes[player]['item']   = index


	-- Count votes
	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	-- Stop votes if limit reached
	if (numVotes == GetNumRaidMembers()) then
		Poll_StopVote()
	end

	return true
end


-- Poll_StartVote( (integer) duration, (integer) maxVotes)
--
-- Starts the voting sequence. Stops after duration seconds or maxVotes votes
-- Both duration and maxVotes are optional

function Poll_StartVote(duration, maxVotes)
	local s

	if (PollVoting == true) then
		return false
	end

	if (#PollItems < 2) then

		return false
	end

	-- set duration
	if  (duration == nil) then
		PollVoteDuration = 0
	else
		duration = tonumber(duration)

		if ((duration ~= nil) and (duration < 0)) then
		  duration = nil
		end

		if (duration == nil) then
			  return false
		end

		PollVoteDuration = duration
	end

	-- set vote limit
	if (maxVotes == nil) then
		PollVoteLimit = 0
	else
		maxVotes = tonumber(maxVotes)

		if (maxVotes ~= nil) then
			maxVotes = math.floor(maxVotes)
			if (maxVotes < 0) then
				maxVotes = nil
			end
		end
	end

	PollVotes = {}
	ElgohVote.TimeSinceLastUpdate = 0
	PollVoting = true
end


-- Poll_StopVote()
--
-- Stops the voting sequence and announces the results.

function Poll_StopVote()
	PollVoting = false
end


-- (table) Poll_GetResults()
--
-- Returns the table of the vote results

function Poll_GetResults()
	local itemsCount = {}
	local player, playerRow, index
	local totalCount = 0

	if (#PollItems == 0) then
		return {}
	end

	for index, _ in pairs(PollItems) do
		itemsCount[index] = {}
		itemsCount[index]['num']  = 0
		itemsCount[index]['item'] = index
	end

	for player, playerRow in pairs(PollVotes) do
		itemsCount[playerRow['item']]['num'] = itemsCount[playerRow['item']]['num'] + 1
		totalCount = totalCount + 1
	end

	table.sort(itemsCount, Poll_CompareResults)

	local resultsTable = {}
	local value
	local position = 1

	if (totalCount == 0) then
		totalCount = 1
	end

	for index, value in pairs(itemsCount) do
		table.insert(resultsTable, position..'. '..
			                         PollItems[value['item']]..' : '..
															 value['num']..
															 ' ('..math.floor(0.5 + 100 * value['num'] / totalCount)..' %)')
		position = position + 1
	end

	return resultsTable
end


-- Poll_ShowResults( (boolean) sayResults)
--
-- Show the vote results or say them if sayResults is truc

function Poll_ShowResults(sayResults)
	local results = Poll_GetResults()

	if (#results == 0) then
		return
	end
end


-- Poll_OrderItems
--
-- Reorder items by index

function Poll_OrderItems()
	local index, itemName
	local indexes, newItemList

	newItemList = {}
	indexes = {}

	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end

	table.sort(indexes)

	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
end

-- Poll_OnLoad()
--
-- Script initialization.

function Poll_OnLoad()
	ElgohVote:RegisterEvent("CHAT_ADDON_MESSAGE")

	ElgohVote.TimeSinceLastUpdate = 0
	PollVoting = false

	ElgohVote:SetScript("OnEvent",  Poll_OnEvent)
	ElgohVote:SetScript("OnUpdate", Poll_OnUpdate)
end


function Poll_OnEvent(event, ...)
if (event == "CHAT_ADDON_MESSAGE") then
	local prefix, msg, how, who = select(1, ...);
	if(msg=="new") then
		PollVoting=true;
	end
end
end


function Poll_OnUpdate(this, arg1)
	if ((not PollVoting) or (PollVoteDuration == 0)) then return end
	
	ElgohVote.TimeSinceLastUpdate = ElgohVote.TimeSinceLastUpdate + arg1
	if( ElgohVote.TimeSinceLastUpdate > PollVoteDuration ) then
		-- End Vote
		Poll_StopVote()
	end
end